-- 百抽盛典
Lua_HundredCeremonyWindow = class("Lua_HundredCeremonyWindow", Lua_Window);
function Lua_HundredCeremonyWindow:ctor(p)
	self:superCall("ctor", p);

	self.windowName = "Lua_HundredCeremonyWindow";
	self.skinName = "HundredCeremonyWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -506;

	self:addPreLoadRes("/images/activities/xui_bcsd_widget_1.png", Lua_LoadFileType.IMG);
	self:addPreLoadRes("/images/activities/xui_bcsd_widget_2.png", Lua_LoadFileType.IMG);
end

function Lua_HundredCeremonyWindow:buildShowItem()
	self:superCall("buildShowItem");

	-- 策划要求屏蔽时间
	self.leftTimeTxt:setEnable(false);

	local arr = DataCenter.hundredCeremonyData.hcGiftInfoArr;
	local item;
	self.showRewardArr = Array();
	for i = 1, arr:getSize() do
		item = Lua_HundredCeremonyItem.new(self.content);
		item.contentName = "Lua_HundredCeremonyItem" .. i;
		item:setCanDoNextState(false);
		item:setData(arr[i]);
		item:setEnable(false);
		item:setLocation(-269 + ((i - 1) % 5) * 135, 103 - Mathf.Ceil(i / 5) * 156);
		self.showRewardArr:add(item);
	end

	self.startIdx = 0;
	self:addTimer("HundredCeremony_ShowReward", 0.1, self, self.showRewardFun);

	self.bannerImg.clickScale = false;
	self.bannerImg:addClickFuntion(self, self.onWinBgClick);

	self:addLuaEvent("UPDATE_HUNDRREDCEREMONY_INFO", self, self.updateHundredCeremonyInfo);
	-- Lua_ProxyManager.getProxy("Lua_HundredCeremonyProxy"):sHundredCeremonyInfo();
	self:updateHundredCeremonyInfo();
end

function Lua_HundredCeremonyWindow:showRewardFun()
	self.startIdx = self.startIdx + 1;
	if self.startIdx > self.showRewardArr:getSize() then
		for i = 1, self.showRewardArr:getSize() do
			self.showRewardArr[i]:setCanDoNextState(true);
		end
		self:removeTimer(self, self.showRewardFun);
		return;
	end
	self.showRewardArr[self.startIdx]:setEnable(true);
end

function Lua_HundredCeremonyWindow:updateHundredCeremonyInfo()
	local arr = DataCenter.hundredCeremonyData.hcGiftInfoArr;
	for i = 1, arr:getSize() do
		self.showRewardArr[i]:setData(arr[i]);
	end

	-- 策划要求屏蔽时间
	-- self:startTimer();
	-- self:updateLeftTime();
end

function Lua_HundredCeremonyWindow:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("HundredCeremony_UpdateLeftTime", 1, self, self.updateLeftTime);
	end
end

function Lua_HundredCeremonyWindow:updateLeftTime()
	local time = DataCenter.hundredCeremonyData.showTime;
	if time <= 0 then
		time = 0;
		self:endTimer();
	end
	self.leftTimeTxt.text = Lua_TimeTransform.transSeconds16(time, true, true, true);
end

function Lua_HundredCeremonyWindow:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_HundredCeremonyWindow:dispose()
	if self.showRewardArr ~= nil then
		self.showRewardArr:dispose();
		self.showRewardArr:clear();
		self.showRewardArr = nil;
	end
	self:removeTimer(self, self.showRewardFun);
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_HundredCeremonyItem = class("Lua_HundredCeremonyItem", Lua_DisplayObject);
function Lua_HundredCeremonyItem:ctor(p)
	self:superCall("ctor", p, "HundredCeremonyItem_skin");
end

function Lua_HundredCeremonyItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setSiblingIndex(0);
	self.itemIcon:setScale(0.94, 0.94);
end

function Lua_HundredCeremonyItem:setData(data)
	self._data = data;

	self.itemIcon:setData(data.hcShowVo);
	self.itemIcon:setDrawMask(data.state == 2);
	if self.isCan then
		self.itemIcon:setClick(self, self.onItemClick);
		self.itemIcon:setCanClick(true);
	else
		self.itemIcon:setClick(nil, nil);
		self.itemIcon:setCanClick(false);
	end

	self.dayTxt.text = LanUtil.formateStr(610000, data.id);
	if data.state > 0 then
		self.dayTxt.colorStr = Lua_ColorDefine.transColor("C9692E");
	else
		self.dayTxt.colorStr = Lua_ColorDefine.transColor("896148");
	end

	self.showIcon:setEnable(data.state == 1);
end

function Lua_HundredCeremonyItem:setCanDoNextState(isCan)
	self.isCan = isCan;
	if isCan then
		self.itemIcon:setClick(self, self.onItemClick);
		self.itemIcon:setCanClick(true);
	end
end

function Lua_HundredCeremonyItem:onItemClick()
	if self.isCan then
		-- 策划要求屏蔽时间
		-- local time = DataCenter.hundredCeremonyData.showTime;
		-- if time > 0 then
			if self._data.state == 0 then
				DataCenter.packUtil:showItemInfo(self.itemIcon.data, self.itemIcon.isShowBtns);
				OperateAlert.show(LanUtil.formateStr(610001, self._data.id));
			elseif self._data.state == 1 then
				Lua_ProxyManager.getProxy("Lua_HundredCeremonyProxy"):sDrawHundredCeremonyReward();
			else
				DataCenter.packUtil:showItemInfo(self.itemIcon.data, self.itemIcon.isShowBtns);
			end
		-- else
		-- 	DataCenter.packUtil:showItemInfo(self.itemIcon.data, self.itemIcon.isShowBtns);
		-- 	OperateAlert.showLangValue(610002);
		-- end
	end
end

function Lua_HundredCeremonyItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end